Index: XIOS/dev/dev_trunk_graph/src/node/context.cpp
===================================================================
--- XIOS/dev/dev_trunk_graph/src/node/context.cpp	(revision 2030)
+++ XIOS/dev/dev_trunk_graph/src/node/context.cpp	(revision 2137)
@@ -73,19 +73,19 @@
 
    //----------------------------------------------------------------
-   void CContext::initEventScheduler(void)
-   {
-     SRegisterContextInfo contextInfo ;
-     CXios::getContextsManager()->getContextInfo(this->getId(), contextInfo, getIntraComm()) ;
-
-     eventScheduler_=CXios::getPoolRessource()->getService(contextInfo.serviceId,contextInfo.partitionId)->getEventScheduler() ;
+
+  void CContext::initEventScheduler(void)
+  {
+    SRegisterContextInfo contextInfo ;
+    CXios::getContextsManager()->getContextInfo(this->getId(), contextInfo, getIntraComm()) ;
+
+    eventScheduler_=CXios::getPoolRessource()->getService(contextInfo.serviceId,contextInfo.partitionId)->getEventScheduler() ;
  
-     // generate unique hash for server
-     auto time=chrono::system_clock::now().time_since_epoch().count() ;
-     std::default_random_engine rd(time); // not reproducible from a run to another
-     std::uniform_int_distribution<size_t> dist;
-     hashId_=dist(rd) ;
-     MPI_Bcast(&hashId_,1,MPI_SIZE_T,0,getIntraComm()) ; // Bcast to all server of the context
-   }
- 
+    // generate unique hash for server
+    auto time=chrono::system_clock::now().time_since_epoch().count() ;
+    std::default_random_engine rd(time); // not reproducible from a run to another
+    std::uniform_int_distribution<size_t> dist;
+    hashId_=dist(rd) ;
+    MPI_Bcast(&hashId_,1,MPI_SIZE_T,0,getIntraComm()) ; // Bcast to all server of the context
+  }
    /*!
    \brief Get context group (context root)
@@ -291,121 +291,4 @@
    ///---------------------------------------------------------------
 
-
-   void CContext::setClientServerBuffer(vector<CField*>& fields, bool bufferForWriting)
-   TRY
-   {
-      // Estimated minimum event size for small events (20 is an arbitrary constant just for safety)
-     const size_t minEventSize = CEventClient::headerSize + 20 * sizeof(int);
-      // Ensure there is at least some room for 20 of such events in the buffers
-     size_t minBufferSize = std::max(CXios::minBufferSize, 20 * minEventSize);
-
-#define DECLARE_NODE(Name_, name_)    \
-     if (minBufferSize < sizeof(C##Name_##Definition)) minBufferSize = sizeof(C##Name_##Definition);
-#define DECLARE_NODE_PAR(Name_, name_)
-#include "node_type.conf"
-#undef DECLARE_NODE
-#undef DECLARE_NODE_PAR
-
-
-     map<CContextClient*,map<int,size_t>> dataSize ;
-     map<CContextClient*,map<int,size_t>> maxEventSize ;
-     map<CContextClient*,map<int,size_t>> attributesSize ;  
-
-     for(auto field : fields)
-     {
-       field->setContextClientDataBufferSize(dataSize, maxEventSize, bufferForWriting) ;
-       field->setContextClientAttributesBufferSize(attributesSize, maxEventSize, bufferForWriting) ;
-     }
-     
-
-     for(auto& it : attributesSize)
-     {
-       auto contextClient = it.first ;
-       auto& contextDataSize =  dataSize[contextClient] ;
-       auto& contextAttributesSize =  attributesSize[contextClient] ;
-       auto& contextMaxEventSize =  maxEventSize[contextClient] ;
-   
-       for (auto& it : contextAttributesSize)
-       {
-         auto serverRank=it.first ;
-         auto& buffer = contextAttributesSize[serverRank] ;
-         if (contextDataSize[serverRank] > buffer) buffer=contextDataSize[serverRank] ;
-         buffer *= CXios::bufferSizeFactor;
-         if (buffer < minBufferSize) buffer = minBufferSize;
-         if (buffer > CXios::maxBufferSize ) buffer = CXios::maxBufferSize;
-       }
-
-       // Leaders will have to send some control events so ensure there is some room for those in the buffers
-       if (contextClient->isServerLeader())
-         for(auto& rank : contextClient->getRanksServerLeader())
-           if (!contextAttributesSize.count(rank))
-           {
-             contextAttributesSize[rank] = minBufferSize;
-             contextMaxEventSize[rank] = minEventSize;
-           }
-      
-       contextClient->setBufferSize(contextAttributesSize, contextMaxEventSize);    
-     }
-   }
-   CATCH_DUMP_ATTR
-
-
-    /*!
-    Sets client buffers.
-    \param [in] contextClient
-    \param [in] bufferForWriting True if buffers are used for sending data for writing
-    This flag is only true for client and server-1 for communication with server-2
-  */
-  // ym obsolete to be removed
-   void CContext::setClientServerBuffer(CContextClient* contextClient, bool bufferForWriting)
-   TRY
-   {
-      // Estimated minimum event size for small events (20 is an arbitrary constant just for safety)
-     const size_t minEventSize = CEventClient::headerSize + 20 * sizeof(int);
-
-      // Ensure there is at least some room for 20 of such events in the buffers
-      size_t minBufferSize = std::max(CXios::minBufferSize, 20 * minEventSize);
-
-#define DECLARE_NODE(Name_, name_)    \
-     if (minBufferSize < sizeof(C##Name_##Definition)) minBufferSize = sizeof(C##Name_##Definition);
-#define DECLARE_NODE_PAR(Name_, name_)
-#include "node_type.conf"
-#undef DECLARE_NODE
-#undef DECLARE_NODE_PAR
-
-     // Compute the buffer sizes needed to send the attributes and data corresponding to fields
-     std::map<int, StdSize> maxEventSize;
-     std::map<int, StdSize> bufferSize = getAttributesBufferSize(maxEventSize, contextClient, bufferForWriting);
-     std::map<int, StdSize> dataBufferSize = getDataBufferSize(maxEventSize, contextClient, bufferForWriting);
-
-     std::map<int, StdSize>::iterator it, ite = dataBufferSize.end();
-     for (it = dataBufferSize.begin(); it != ite; ++it)
-       if (it->second > bufferSize[it->first]) bufferSize[it->first] = it->second;
-
-     // Apply the buffer size factor, check that we are above the minimum buffer size and below the maximum size
-     ite = bufferSize.end();
-     for (it = bufferSize.begin(); it != ite; ++it)
-     {
-       it->second *= CXios::bufferSizeFactor;
-       if (it->second < minBufferSize) it->second = minBufferSize;
-       if (it->second > CXios::maxBufferSize) it->second = CXios::maxBufferSize;
-     }
-
-     // Leaders will have to send some control events so ensure there is some room for those in the buffers
-     if (contextClient->isServerLeader())
-     {
-       const std::list<int>& ranks = contextClient->getRanksServerLeader();
-       for (std::list<int>::const_iterator itRank = ranks.begin(), itRankEnd = ranks.end(); itRank != itRankEnd; ++itRank)
-       {
-         if (!bufferSize.count(*itRank))
-         {
-           bufferSize[*itRank] = minBufferSize;
-           maxEventSize[*itRank] = minEventSize;
-         }
-       }
-     }
-     contextClient->setBufferSize(bufferSize, maxEventSize);
-   }
-   CATCH_DUMP_ATTR
 
  /*!
@@ -716,9 +599,15 @@
   CATCH_DUMP_ATTR
 
-   
-  bool CContext::eventLoop(bool enableEventsProcessing)
+  void CContext::globalEventLoop(void)
   {
-    bool finished=true; 
-    bool out; 
+    lockContext() ;
+    CXios::getDaemonsManager()->eventLoop() ;
+    unlockContext() ;
+    setCurrent(getId()) ;
+  }
+
+  bool CContext::scheduledEventLoop(bool enableEventsProcessing) 
+  {
+    bool out, finished; 
     size_t timeLine=timeLine_ ;
     if (serviceType_==CServicesManager::CLIENT)
@@ -730,29 +619,41 @@
     do
     { 
-      if (client!=nullptr && !finalized) client->checkBuffers();
-    
-      for (int i = 0; i < clientPrimServer.size(); ++i)
-      {
-        if (!finalized) clientPrimServer[i]->checkBuffers();
-        if (!finalized) finished &= serverPrimServer[i]->eventLoop(enableEventsProcessing);
-      }
-
-      for (auto couplerOut : couplerOutClient_)
-        if (!finalized) couplerOut.second->checkBuffers();
-    
-      for (auto couplerIn : couplerInClient_)
-        if (!finalized) couplerIn.second->checkBuffers();
-    
-      for (auto couplerOut : couplerOutServer_)
-        if (!finalized) couplerOut.second->eventLoop(enableEventsProcessing);
-
-      for (auto couplerIn : couplerInServer_)
-        if (!finalized) couplerIn.second->eventLoop(enableEventsProcessing);
-    
-      if (server!=nullptr) if (!finalized) finished &= server->eventLoop(enableEventsProcessing);
-  
+      finished=eventLoop(enableEventsProcessing) ;
       if (serviceType_==CServicesManager::CLIENT) out = eventScheduler_->queryEvent(timeLine,hashId_) ;
       else out=true ;
     }  while(!out) ;
+    
+    return finished ;
+  }
+
+  bool CContext::eventLoop(bool enableEventsProcessing)
+  {
+    bool  finished; 
+    if (isLockedContext()) return ;
+    
+    setCurrent(getId()) ;
+
+    if (client!=nullptr && !finalized) client->checkBuffers();
+    
+    for (int i = 0; i < clientPrimServer.size(); ++i)
+    {
+      if (!finalized) clientPrimServer[i]->checkBuffers();
+      if (!finalized) finished &= serverPrimServer[i]->eventLoop(enableEventsProcessing);
+    }
+
+    for (auto couplerOut : couplerOutClient_)
+      if (!finalized) couplerOut.second->checkBuffers();
+    
+    for (auto couplerIn : couplerInClient_)
+      if (!finalized) couplerIn.second->checkBuffers();
+    
+    for (auto couplerOut : couplerOutServer_)
+      if (!finalized) couplerOut.second->eventLoop(enableEventsProcessing);
+
+    for (auto couplerIn : couplerInServer_)
+      if (!finalized) couplerIn.second->eventLoop(enableEventsProcessing);
+    
+    if (server!=nullptr) if (!finalized) finished &= server->eventLoop(enableEventsProcessing);
+    setCurrent(getId()) ;
     return finalized && finished ;
   }
@@ -784,18 +685,4 @@
         couplerOutClient_[fullContextId] = client ;
         couplerOutServer_[fullContextId] = server ;
-
-/*
-      // for now, we don't now which beffer size must be used for client coupler
-      // It will be evaluated later. Fix a constant size for now...
-      // set to 10Mb for development
-       map<int,size_t> bufferSize, maxEventSize ;
-       for(int i=0;i<client->getRemoteSize();i++)
-       {
-         bufferSize[i]=10000000 ;
-         maxEventSize[i]=10000000 ;
-       }
-
-       client->setBufferSize(bufferSize, maxEventSize);    
-*/
       }
     }
@@ -819,12 +706,4 @@
        MPI_Comm_free(&interComm) ;
 
-       map<int,size_t> bufferSize, maxEventSize ;
-       for(int i=0;i<client->getRemoteSize();i++)
-       {
-         bufferSize[i]=10000000 ;
-         maxEventSize[i]=10000000 ;
-       }
-
-       client->setBufferSize(bufferSize, maxEventSize);    
        couplerInClient_[fullContextId] = client ;
        couplerInServer_[fullContextId] = server ;        
@@ -832,11 +711,4 @@
   }
   
-  void CContext::globalEventLoop(void)
-  {
-    CXios::getDaemonsManager()->eventLoop() ;
-    setCurrent(getId()) ;
-  }
-
-
    void CContext::finalize(void)
    TRY
@@ -1023,6 +895,7 @@
 
     bool workflowGraphIsCompleted ;
-
+    
     bool first=true ;
+   
     do
     {
@@ -1032,5 +905,5 @@
         workflowGraphIsCompleted &= endWorkflowField->buildWorkflowGraph(garbageCollector) ;
       }
-
+   
       for(auto couplerIn : enabledCouplerIn) couplerIn->assignContext() ;
       for(auto field : couplerInField) field->makeGridAliasForCoupling();
@@ -1045,6 +918,5 @@
         // connect to couplerOut -> to do
       }
-      if (first) setClientServerBuffer(couplerOutField, true) ; // set buffer context --> to check
-   
+
       bool couplersReady ;
       do 
@@ -1057,10 +929,13 @@
           couplersReady &= ready ;
         }
-        this->eventLoop() ;
+        this->scheduledEventLoop() ;
+
       } while (!couplersReady) ;
-
+      
       first=false ;
-      this->eventLoop() ;
+      this->scheduledEventLoop() ;
+
     } while (!workflowGraphIsCompleted) ;
+
 
     for( auto field : couplerInField) couplerInFields_.push_back(field) ;
@@ -1087,5 +962,4 @@
         field->connectToFileServer(garbageCollector) ; // connect the field to server filter
       }
-      setClientServerBuffer(fileOutField, true) ; // set buffer context --> to review
       for(auto field : fileOutField) field->sendFieldToFileServer() ;
     }
@@ -1193,6 +1067,16 @@
       ok = true ;
       for(auto& couplerOutClient : couplerOutClient_) ok &= isCouplerInCloseDefinition(couplerOutClient.second) ;
-      this->eventLoop() ; 
+      this->scheduledEventLoop() ;
     } while (!ok) ;
+
+    // Now evaluate the size of the context client buffers
+    map<CContextClient*,map<int,size_t>> fieldBufferEvaluation ;
+    for(auto field : fileOutField) field->evaluateBufferSize(fieldBufferEvaluation, CXios::isOptPerformance) ; // output to server
+    for(auto field : couplerOutField) field->evaluateBufferSize(fieldBufferEvaluation, CXios::isOptPerformance) ; // output to coupler
+    for(auto field : fieldModelIn) field->evaluateBufferSize(fieldBufferEvaluation, CXios::isOptPerformance) ; // server to client (for io servers)
+    
+    // fix size for each context client
+    for(auto& it : fieldBufferEvaluation) it.first->setBufferSize(it.second) ;
+
 
      CTimer::get("Context : close definition").suspend() ;
Index: XIOS/dev/dev_trunk_graph/src/node/context.hpp
===================================================================
--- XIOS/dev/dev_trunk_graph/src/node/context.hpp	(revision 2030)
+++ XIOS/dev/dev_trunk_graph/src/node/context.hpp	(revision 2137)
@@ -15,4 +15,5 @@
 #include "server_context.hpp"
 #include "event_scheduler.hpp"
+
 
 namespace xios
@@ -108,4 +109,5 @@
          // Put sever or client into loop state
          bool eventLoop(bool enableEventsProcessing=true);
+         bool scheduledEventLoop(bool enableEventsProcessing=true) ; 
          void globalEventLoop(void);
 
@@ -148,6 +150,4 @@
          std::map<int, StdSize> getAttributesBufferSize(std::map<int, StdSize>& maxEventSize, CContextClient* contextClient, bool bufferForWriting = false);
          std::map<int, StdSize> getDataBufferSize(std::map<int, StdSize>& maxEventSize, CContextClient* contextClient, bool bufferForWriting = false);
-         void setClientServerBuffer(CContextClient* contextClient, bool bufferForWriting = false); // old interface to be removed
-         void setClientServerBuffer(vector<CField*>& fields, bool bufferForWriting) ; 
 
          // Distribute files (in write mode) among secondary-server pools according to the estimated data flux
@@ -355,6 +355,14 @@
          string contextId_ ; //!< context client id for the servers. For clients this is same as getId() 
          bool isProcessingEvent_ ;
+    private:     
          CServerContext* parentServerContext_ ;
-
+    public:
+         CServerContext* getParentServerContext(void) { return parentServerContext_; }
+    private: 
+      bool lockedContext_=false;
+    public: 
+        void lockContext(void) {lockedContext_=true; }
+        void unlockContext(void) {lockedContext_=true; }
+        bool isLockedContext(void) { return lockedContext_;}
       public: // Some function maybe removed in the near future
         // virtual void toBinary  (StdOStream & os) const;
Index: XIOS/dev/dev_trunk_graph/src/node/domain.cpp
===================================================================
--- XIOS/dev/dev_trunk_graph/src/node/domain.cpp	(revision 2030)
+++ XIOS/dev/dev_trunk_graph/src/node/domain.cpp	(revision 2137)
@@ -805,10 +805,13 @@
         nj = 1;
         jbegin = 0;
-        if (!i_index.isEmpty()) ni = i_index.numElements();
-        j_index.resize(ni);
-        for(int i=0;i<ni;++i) j_index(i)=0;
-
-        if (!area.isEmpty())
-          area.transposeSelf(1, 0);
+        if (!i_index.isEmpty()) 
+        {
+          ni = i_index.numElements();
+          j_index.resize(ni);
+          for(int i=0;i<ni;++i) j_index(i)=0;
+        }
+        
+
+        if (!area.isEmpty()) area.transposeSelf(1, 0); // => to be checked why is it transposed
      }
 
@@ -1780,4 +1783,5 @@
    }
 
+
   string CDomain::getCouplingAlias(const string& fieldId, int posInGrid)
   {
@@ -1808,5 +1812,5 @@
   void CDomain::makeAliasForCoupling(const string& fieldId, int posInGrid)
   {
-     const string domainId = getCouplingAlias(fieldId, posInGrid);
+    const string domainId = getCouplingAlias(fieldId, posInGrid);
     this->createAlias(domainId) ;
   }
Index: XIOS/dev/dev_trunk_graph/src/node/extract_domain_to_axis.cpp
===================================================================
--- XIOS/dev/dev_trunk_graph/src/node/extract_domain_to_axis.cpp	(revision 2030)
+++ XIOS/dev/dev_trunk_graph/src/node/extract_domain_to_axis.cpp	(revision 2137)
@@ -67,13 +67,13 @@
     {
       case direction_attr::jDir:
-        if (axis_n_glo != domain_ni_glo)
+        if (axis_n_glo != domain_nj_glo)
           ERROR("CExtractDomainToAxis::checkValid(CAxis* axisDst, CDomain* domainSrc)",
-            << "Extract domain along j, axis destination should have n_glo equal to ni_glo of domain source"
-            << "Domain source " <<domainSrc->getId() << " has nj_glo " << domain_ni_glo << std::endl
+            << "Extract domain along j, axis destination should have n_glo equal to nj_glo of domain source"
+            << "Domain source " <<domainSrc->getId() << " has nj_glo " << domain_nj_glo << std::endl
             << "Axis destination " << axisDst->getId() << " has n_glo " << axis_n_glo);
-        if ((position < 0) || (position > domain_ni_glo))
+        if ((position < 0) || (position >= domain_ni_glo))
         ERROR("CExtractDomainToAxis::checkValid(CAxis* axisDst, CDomain* domainSrc)",
-          << "Extract domain along j, position should be inside 0 and ni_glo of domain source"
-          << "Domain source " <<domainSrc->getId() << " has nj_glo " << domain_ni_glo << std::endl
+          << "Extract domain along j, position should be inside 0 and ni_glo-1 of domain source"
+          << "Domain source " <<domainSrc->getId() << " has ni_glo " << domain_ni_glo << std::endl
           << "Axis destination " << axisDst->getId() << std::endl
           << "Position " << position);
@@ -81,13 +81,13 @@
 
       case direction_attr::iDir:
-        if (axis_n_glo != domain_nj_glo)
+        if (axis_n_glo != domain_ni_glo)
           ERROR("CExtractDomainToAxis::checkValid(CAxis* axisDst, CDomain* domainSrc)",
-            << "Extract domain along i, axis destination should have n_glo equal to nj_glo of domain source"
-            << "Domain source " <<domainSrc->getId() << " has nj_glo " << domain_nj_glo << std::endl
+            << "Extract domain along i, axis destination should have n_glo equal to ni_glo of domain source"
+            << "Domain source " <<domainSrc->getId() << " has ni_glo " << domain_ni_glo << std::endl
             << "Axis destination " << axisDst->getId() << " has n_glo " << axis_n_glo);
-        if ((position < 0) || (position > domain_nj_glo))
+        if ((position < 0) || (position >= domain_nj_glo))
         ERROR("CExtractDomainToAxis::checkValid(CAxis* axisDst, CDomain* domainSrc)",
-          << "Extract domain along i, position should be inside 0 and nj_glo of domain source"
-          << "Domain source " <<domainSrc->getId() << " has nj_glo " << domain_ni_glo << std::endl
+          << "Extract domain along i, position should be inside 0 and nj_glo-1 of domain source"
+          << "Domain source " <<domainSrc->getId() << " has nj_glo " << domain_nj_glo << std::endl
           << "Axis destination " << axisDst->getId() << std::endl
           << "Position " << position);
Index: XIOS/dev/dev_trunk_graph/src/node/field.cpp
===================================================================
--- XIOS/dev/dev_trunk_graph/src/node/field.cpp	(revision 2030)
+++ XIOS/dev/dev_trunk_graph/src/node/field.cpp	(revision 2137)
@@ -383,4 +383,5 @@
   CATCH_DUMP_ATTR
 
+  
   //----------------------------------------------------------------
 
@@ -497,4 +498,42 @@
   CATCH_DUMP_ATTR
 
+  bool CField::evaluateBufferSize(map<CContextClient*,map<int,size_t>>& evaluateBuffer, bool isOptPerformance)
+  {
+    CContextClient* client=nullptr ;
+
+    for(int i=0;i<2;i++)
+    {
+      map<int,int> dataSize ;
+      if (i==0  && clientToServerStoreFilter_) client = clientToServerStoreFilter_-> getTransferedDataSize(dataSize) ;
+      if (i==1  && serverToClientStoreFilter_) client = serverToClientStoreFilter_-> getTransferedDataSize(dataSize) ;
+
+      if (client!=nullptr)
+      {
+        map<int,size_t> bufferSize ;
+   
+        if (evaluateBuffer.count(client)!=0) bufferSize = evaluateBuffer[client] ;
+        if (isOptPerformance)
+        {
+          for(auto& it : dataSize) 
+          {
+            if (bufferSize.count(it.first)==0) bufferSize[it.first]=it.second ;
+            else bufferSize[it.first]+=it.second ;
+          }
+        }
+        else
+        {
+          for(auto& it : dataSize) 
+          {
+            if (bufferSize.count(it.first)==0) bufferSize[it.first]=it.second ;
+            else bufferSize[it.first]=std::max(bufferSize[it.first],(size_t)it.second) ;
+          }
+        }
+        evaluateBuffer[client] = bufferSize ;
+        client=nullptr ;
+      }
+    }
+    if (client==nullptr) return false ;
+    else return true;
+  }  
 
 
@@ -550,21 +589,11 @@
     bool buildGraph_ = !build_workflow_graph.isEmpty() && build_workflow_graph == true ;
     std::cout<<"field id="<<this->getId()<<" build_workflow_graph="<<buildGraph_<<std::endl;
-
-    if (!inputFilter) 
-    {
-      inputFilter = std::shared_ptr<CPassThroughFilter>(new CPassThroughFilter(gc)); 
-      /*if(buildGraph_)
-      {
-        std::cout<<"============== field "<<this->getId()<<" calls a pass through filter ============== "<<inputFilter<<" ***** "<<CXios::isClient<<std::endl;
-        inputFilter->graphEnabled = true;
-        inputFilter->graphPackage = new CGraphPackage;
-        inputFilter->graphPackage->inFields.push_back(this);
-      }*/
-    }
+    if (!inputFilter) inputFilter = std::shared_ptr<CPassThroughFilter>(new CPassThroughFilter(gc)); 
      
     if (hasDirectFieldReference())
     {
-      
       CField* fieldRef = getDirectFieldReference();
+
+      //------ build_workflow_graph start
       if(buildGraph_)
       {
@@ -580,4 +609,6 @@
       
       if(buildGraph_) this->build_workflow_graph.set(build_workflow_graph);
+      //------ build_workflow_graph end
+
       bool ret=fieldRef->buildWorkflowGraph(gc); 
       if (!ret) return false ; // workflow graph cannot be built at this stage
@@ -612,20 +643,8 @@
       {
         grid->solveElementsRefInheritance() ;
-       
-        // new
-        
         std::pair<std::shared_ptr<CFilter>, std::shared_ptr<CFilter> > filters = grid->buildTransformationGraph(gc, false,  gridSrc, detectMissingValues, defaultValue, newGrid, buildGraph_, this) ;
         lastFilter->connectOutput(filters.first, 0);
-        /*if(buildGraph_)
-        {
-          std::cout<<"============== field "<<this->getId()<<" calls a transformation filter 1 ============== "<<lastFilter<<" _ "<<filters.first<<" ***** "<<CXios::isClient<<std::endl;
-          filters.first->graphEnabled=true;
-          filters.first->graphPackage = new CGraphPackage;
-          filters.first->graphPackage->inFields.push_back(this);
-        }*/
         lastFilter = filters.second;
         gridSrc = newGrid ;
-
-        // end new
       }
 
@@ -658,6 +677,8 @@
          grid_ = newGrid ;
          grid_ref=grid_->getId() ; // for server 
+         //grid_->completeGrid(); // grid generation, to be checked
          if (fileIn_->isClientSide()) fileIn_->readFieldAttributesValues(this);
          grid_->checkElementsAttributes() ;
+//         grid_->solveDomainAxisBaseRef();
          // probably in future tag grid incomplete if coming from a reading
          instantDataFilter=inputFilter ;
@@ -927,4 +948,52 @@
    * \return the output pin corresponding to a self reference
    */
+
+/* old version
+  std::shared_ptr<COutputPin> CField::getSelfReference(CGarbageCollector& gc)
+  TRY
+  {
+    if (instantDataFilter || !hasExpression())
+      ERROR("COutputPin* CField::getSelfReference(CGarbageCollector& gc)",
+            "Impossible to add a self reference to a field which has already been parsed or which does not have an expression.");
+
+    if (!selfReferenceFilter)
+    {
+      const bool detectMissingValues = (!detect_missing_value.isEmpty() && !default_value.isEmpty() && detect_missing_value == true);
+      const double defaultValue  = detectMissingValues ? default_value : (!default_value.isEmpty() ? default_value : 0.0);
+
+      if (file && !file->mode.isEmpty() && file->mode == CFile::mode_attr::read)
+      {
+        if (!serverSourceFilter)
+        {
+          checkTimeAttributes();
+          serverSourceFilter = std::shared_ptr<CSourceFilter>(new CSourceFilter(gc, grid_, true, false, freq_offset, true,
+                                                              detectMissingValues, defaultValue));
+         }
+
+        selfReferenceFilter = serverSourceFilter;
+      }
+      else if (!field_ref.isEmpty())
+      {
+        CField* fieldRef = CField::get(field_ref);
+        fieldRef->buildFilterGraph(gc, false);
+        selfReferenceFilter = fieldRef->getInstantDataFilter();
+      }
+      else
+      {
+        if (!clientSourceFilter)
+        {
+          if (check_if_active.isEmpty()) check_if_active = false;
+          clientSourceFilter = std::shared_ptr<CSourceFilter>(new CSourceFilter(gc, grid_, true, true, NoneDu, false,
+                                                                                detectMissingValues, defaultValue));
+        }
+
+        selfReferenceFilter = clientSourceFilter;
+      }
+    }
+
+    return selfReferenceFilter;
+  }
+  CATCH_DUMP_ATTR
+*/
   std::shared_ptr<COutputPin> CField::getSelfReference(CGarbageCollector& gc)
   TRY
@@ -1030,4 +1099,39 @@
   CATCH_DUMP_ATTR
 
+/* old version   
+  std::shared_ptr<COutputPin> CField::getSelfTemporalDataFilter(CGarbageCollector& gc, CDuration outFreq)
+  TRY
+  {
+    if (instantDataFilter || !hasExpression())
+      ERROR("COutputPin* CField::getSelfTemporalDataFilter(CGarbageCollector& gc)",
+            "Impossible to add a self reference to a field which has already been parsed or which does not have an expression.");
+
+    if (!selfReferenceFilter) getSelfReference(gc) ;
+
+    if (serverSourceFilter || clientSourceFilter)
+    {
+      if (operation.isEmpty())
+        ERROR("void CField::getSelfTemporalDataFilter(CGarbageCollector& gc, CDuration outFreq)",
+              << "An operation must be defined for field \"" << getId() << "\".");
+
+      checkTimeAttributes(&outFreq);
+
+      const bool detectMissingValues = (!detect_missing_value.isEmpty() && detect_missing_value == true);
+      std::shared_ptr<CTemporalFilter> temporalFilter(new CTemporalFilter(gc, operation,
+                                                                          CContext::getCurrent()->getCalendar()->getInitDate(),
+                                                                          freq_op, freq_offset, outFreq, detectMissingValues));
+
+      selfReferenceFilter->connectOutput(temporalFilter, 0);
+      return temporalFilter ;
+    }
+    else if (!field_ref.isEmpty())
+    {
+      CField* fieldRef = CField::get(field_ref);
+      fieldRef->buildFilterGraph(gc, false); 
+      return fieldRef->getTemporalDataFilter(gc, outFreq) ;
+    }
+  }
+  CATCH_DUMP_ATTR
+*/
 
   //----------------------------------------------------------------
@@ -1355,15 +1459,13 @@
    CATCH_DUMP_ATTR
 
-
-   bool CField::isGridCompleted(void)
-   TRY
-   { 
-     bool isFullCompleted ;
-     MPI_Allreduce(&isGridCompleted_,&isFullCompleted,1,MPI_C_BOOL, MPI_LAND, CContext::getCurrent()->getIntraComm() ) ;
-     if ( (isGridCompleted_==false && isFullCompleted==true) ) ERROR("bool CField::isGridCompleted(void)",<< "incoherecy in MPI_AllReduce") ;
-     return isFullCompleted ; 
-   }
-   CATCH_DUMP_ATTR
-
+  bool CField::isGridCompleted(void)
+  TRY
+  { 
+    bool isFullCompleted ;
+    MPI_Allreduce(&isGridCompleted_,&isFullCompleted,1,MPI_C_BOOL, MPI_LAND, CContext::getCurrent()->getIntraComm() ) ;
+    if ( (isGridCompleted_==false && isFullCompleted==true) ) ERROR("bool CField::isGridCompleted(void)",<< "incoherecy in MPI_AllReduce") ;
+    return isFullCompleted ; 
+  }
+  CATCH_DUMP_ATTR
 
   void CField::sendAddAllVariables(CContextClient* client)
Index: XIOS/dev/dev_trunk_graph/src/node/field.hpp
===================================================================
--- XIOS/dev/dev_trunk_graph/src/node/field.hpp	(revision 2030)
+++ XIOS/dev/dev_trunk_graph/src/node/field.hpp	(revision 2137)
@@ -110,5 +110,7 @@
          // Grid data buffer size for each connection of contextclient
          std::map<int, StdSize> getGridDataBufferSize(CContextClient* client, bool bufferForWriting = false);
-
+         
+         // evaluation the size of the buffer for the field
+         bool evaluateBufferSize(map<CContextClient*,map<int,size_t>>& evaluateBuffer, bool isOptPerformance) ;
        public:
           void makeGridAliasForCoupling(void) ;
@@ -236,5 +238,5 @@
           bool isGridCompleted_ = true ;
       public:
-          bool isGridCompleted() ; 
+          bool isGridCompleted()  ; 
           void setGridCompleted(void) { isGridCompleted_= true; }
           void unsetGridCompleted(void) { isGridCompleted_ = false ;}
